/* Écriture de données numériques en EEPROM pour développer les séquences qui dans le programme traiteront
   des zones "numériques".
   L'écriture s'achève par un listage du contenu de l'EEPROM en HEXAdécimal.  */
int PTR;
float I_Total_Annee; // Courant total fourni par les panneaux solaires.
float W_Echantillon_Journalier;
float W_Journaliere;

void setup() { Serial.begin(115200);}

void loop() {
  Ecrire_un_Entier_en_EEPROM(0, 123); // Ordre du jour dans l'année = 123.
  Ecrire_un_Octet_en_EEPROM(2, 19); // Jour de la RAZ : 19.
  Ecrire_un_Octet_en_EEPROM(3, 5); // Mois de la RAZ : Mai.
  Ecrire_un_Float_en_EEPROM(4,90082.12345); // Énergie totale année.
  PTR = 8; W_Journaliere = 7200.12345; // Écrit 7 jours pour une semaine.
  for (byte I = 0; I < 7; I++)
      {Ecrire_un_Float_en_EEPROM(PTR,W_Journaliere); W_Journaliere = W_Journaliere - 1000;}
  Ecrire_un_Float_en_EEPROM(36,1.234); // Journée minimale en mAH.
  Ecrire_un_Float_en_EEPROM(40,7345.6); // Journée MAXimale en mAH.
  Ecrire_un_Entier_en_EEPROM(44, 73); // Nombre de jours écoulés depuis la RAZ.
  PTR = 64; // Écriture de 105 bytes pour la journée courante.
  for (byte I = 0; I < 90; I++) Ecrire_un_Octet_en_EEPROM(PTR, I * 2);
  // Écriture de 105 bytes pour la Veille.
  for (byte I = 0; I < 90; I++) Ecrire_un_Octet_en_EEPROM(PTR, 180 - (I * 2));
  // Écriture de 105 bytes pour la journée MAXimale.
  for (byte I = 0; I < 90; I++) Ecrire_un_Octet_en_EEPROM(PTR, (I * 2) + 50);
  // Écriture de 105 bytes pour la journée Minimale.
  for (byte I = 0; I < 90; I++) Ecrire_un_Octet_en_EEPROM(PTR, 250 - (I * 2));
  // Écriture de 52 float pour les semaines annuelles.
  Ecrire_un_Float_en_EEPROM(PTR, 0.0); Ecrire_un_Float_en_EEPROM(PTR, 10.0);
  Ecrire_un_Float_en_EEPROM(PTR, 15.0); Ecrire_un_Float_en_EEPROM(PTR, 20.0);
  Ecrire_un_Float_en_EEPROM(PTR, 30.0); Ecrire_un_Float_en_EEPROM(PTR, 40.0);
  Ecrire_un_Float_en_EEPROM(PTR, 45.0); Ecrire_un_Float_en_EEPROM(PTR, 35.0);
  Ecrire_un_Float_en_EEPROM(PTR, 25.0); Ecrire_un_Float_en_EEPROM(PTR, 0.0);
  Ecrire_un_Float_en_EEPROM(PTR, 2.0); Ecrire_un_Float_en_EEPROM(PTR, 4.0);
  Ecrire_un_Float_en_EEPROM(PTR, 6.0); Ecrire_un_Float_en_EEPROM(PTR, 8.0);
  Ecrire_un_Float_en_EEPROM(PTR, 10.0); Ecrire_un_Float_en_EEPROM(PTR, 12.0);
  Ecrire_un_Float_en_EEPROM(PTR, 14.0); Ecrire_un_Float_en_EEPROM(PTR, 16.0);
  Ecrire_un_Float_en_EEPROM(PTR, 18.0); Ecrire_un_Float_en_EEPROM(PTR, 20.0);
  Ecrire_un_Float_en_EEPROM(PTR, 22.0); Ecrire_un_Float_en_EEPROM(PTR, 24.0);
  Ecrire_un_Float_en_EEPROM(PTR, 26.0); Ecrire_un_Float_en_EEPROM(PTR, 28.0);
  Ecrire_un_Float_en_EEPROM(PTR, 30.0); Ecrire_un_Float_en_EEPROM(PTR, 32.0);
  Ecrire_un_Float_en_EEPROM(PTR, 34.0); Ecrire_un_Float_en_EEPROM(PTR, 36.0);
  Ecrire_un_Float_en_EEPROM(PTR, 38.0); Ecrire_un_Float_en_EEPROM(PTR, 40.0);
  Ecrire_un_Float_en_EEPROM(PTR, 42.0); Ecrire_un_Float_en_EEPROM(PTR, 44.0);
  Ecrire_un_Float_en_EEPROM(PTR, 42.0); Ecrire_un_Float_en_EEPROM(PTR, 41.0);
  Ecrire_un_Float_en_EEPROM(PTR, 40.0); Ecrire_un_Float_en_EEPROM(PTR, 39.0);
  Ecrire_un_Float_en_EEPROM(PTR, 38.0); Ecrire_un_Float_en_EEPROM(PTR, 37.0);
  Ecrire_un_Float_en_EEPROM(PTR, 36.0); Ecrire_un_Float_en_EEPROM(PTR, 35.0);
  Ecrire_un_Float_en_EEPROM(PTR, 34.0); Ecrire_un_Float_en_EEPROM(PTR, 33.0);
  Ecrire_un_Float_en_EEPROM(PTR, 32.0); Ecrire_un_Float_en_EEPROM(PTR, 31.0);
  Ecrire_un_Float_en_EEPROM(PTR, 30.0); Ecrire_un_Float_en_EEPROM(PTR, 29.0);
  Ecrire_un_Float_en_EEPROM(PTR, 28.0); Ecrire_un_Float_en_EEPROM(PTR, 27.0);
  Ecrire_un_Float_en_EEPROM(PTR, 26.0); Ecrire_un_Float_en_EEPROM(PTR, 25.0);
  Ecrire_un_Float_en_EEPROM(PTR, 24.0); Ecrire_un_Float_en_EEPROM(PTR, 23.0);
  Ecrire_un_Octet_en_EEPROM(46,21); // Jour MAXI.
  Ecrire_un_Octet_en_EEPROM(47,6);  // Mois MAXI.
  Ecrire_un_Octet_en_EEPROM(48,21); // Jour mini.
  Ecrire_un_Octet_en_EEPROM(49,12); // Mois mini.
  Ecrire_un_Octet_en_EEPROM(51,7); // La semaine n°2 commence le jour n°7 en 2019.
  Ecrire_un_Octet_en_EEPROM(52,22); // Date du jour Spécial.
  Ecrire_un_Octet_en_EEPROM(53,2);  // Mois du jour Spécial.
  // L'instruction ci-avant est impérative pour avoir une valeur initiale cohérente.
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
//--------------------- Routines pour la gestion EEPROM ---------------------
byte Lire_un_Octet_en_EEPROM(int PTR) {
  return eeprom_read_byte((unsigned char*) PTR);}

void Ecrire_un_Octet_en_EEPROM(int ADRESSE, byte OCTET) { // Pointe l'octet libre suivant.
   eeprom_write_byte((unsigned char *) ADRESSE, OCTET); PTR++;}

int Lire_un_Entier_en_EEPROM(int ADRESSE) {return eeprom_read_word((unsigned int *) ADRESSE);}

void Ecrire_un_Entier_en_EEPROM(int ADRESSE, int MOT16Bits) { // Pointe l'octet libre suivant.
   eeprom_write_word((unsigned int *) ADRESSE, MOT16Bits); PTR++; PTR++;}

float Lire_un_Float_en_EEPROM(int ADRESSE) {return eeprom_read_float((float *) ADRESSE);}

void Ecrire_un_Float_en_EEPROM(int ADRESSE, float REEL) { // Pointe l'octet libre suivant.
   eeprom_write_float((float *) ADRESSE, REEL); PTR++; PTR++; PTR++; PTR++;}

//---------------------------------------------------------------------------
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = Lire_un_Octet_en_EEPROM(PTR);
  if (octet < 16) Serial.print('0'); 
  Serial.print(octet,HEX);
  Serial.print(' '); PTR++; }
