/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus elle est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(60); } // 60 caractères sont très suffisants.

void loop() { // Les textes sont logés en fin d'EEPROM. 
  PTR = 632; // PTR pointe la première adresse pour les textes, la fin étant en 1023.    

  // Ci-dessous : "Purger" l'EEPROM avec des #FF pour le cas où elle ne serait pas vierge.
  for (int i=0; i < 1024; i++) EEPROM.write(i, 255);
  
  TEXTE_a_inscrire_en_EEPROM = " VALEUR = Ordre USB = W EXTREMESNb joursSmn n > J"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "la sMoy / LundiMardiMercrediJeudiVendrediSamediDimanche"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "SEC.COURT :Min + 1"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "MAXminJ-150403020101215218"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Plus de 365 J !RAZ le BP+ Long : RAZ !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Veille  : Semaine : AHAnnee   : Cumuls au Jour n"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Le - mAH BOLOMETREU cellules = I Totale   = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Puissance  = Bilan Jr = IN Arduino = I Recharge = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "I Totale   = U cellules = IN Arduino = U PILE SAV = "; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "////U PILE n"; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE.
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
