/* Programme qui permet de mettre à jour l'horloge calendrier du BOLOMETRE avec le moniteur de l'IDE.
   
   ************************** UTILISATION DU PROGRAMME. **************************
   • Brancher la ligne USB sur le PC et passer sur le Moniteur de l'IDE. (115200bauds.)
   • L'écran du PC liste les commandes. (Rappel des commandes par la consigne "c".
   • Sur l'afficheur OLED le cadre du haut indique la valeur de la pile de sauvegarde.
   • Sur chaque commande élémentaire valide l'Horloge/Calendrier est mise à jour.
   • Sur RESET les valeurs sont récupérées sur le module Horloge/Calendrier.
   • Un BIP sonore est généré si la valeur est hors limites valides.
   • Un BIP sonore est généré sur caractère de commande incorrect.
   • Mis à part "M" pour le mois et "m" pour les minutes, toutes les autres commandes acceptent
     minuscule ou majuscule. (L'espace entre caractère de commande et valeur n'est pas obligatoire.)
   *******************************************************************************

   Programme : 18200 octets 59%  Mémoire dynamique :   1257 octets 61%   */

//--------------------- Déclarations pour le matériel -----------------------
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)

#include <Wire.h>
#include <Rtc_Pcf8563.h>
// Initialisation de l'horloge temps réel.
Rtc_Pcf8563 rtc;

//--------------------- Définition des broches d'E/S ------------------------
#define LED_Verte 12 // Témoin de la boucle de base.
#define BUZZER 9 // Pilotage du bruiteur.
#define Entree_U_Pile_Horloge 3 // Entrée analogique A3 pour mesurer la tension pile de sauvegarde.
//-------------------- Déclaration des constantes --------------------
#define T_base_millisecondes 996  // Durée globale entre deux mesures exprimée en mS.
                                  // Valeur affinée en fonction de la QRG du quartz.
#define Correction_U_Pile_sauvegarde 0.0044965 // Pile de sauvegarde de l'horloge. (0.0044965 = 0.92 x 5 / 1023)
#define TailleTexte 10 // Taille réservée pour LGR_MAX plus le délimiteur.

//-------------------- Déclaration des variables ---------------------                                
int ARGUMENT;
char CAR; // Caractère de consigne.
byte I = 0; // Pointeur dans la chaine TEXTE.
byte Heures, Minutes, Secondes, Jour, Mois, J_Semaire, Annee;
unsigned long Ancienne_valeur_Temps_Ecoule_depuis_RESET;
float U_Pile_Horloge; // Tension U de la pile de sauvegarde horloge.
char TEXTE[TailleTexte]; // Place pour LGR_MAX caractères plus le délimiteur.

void setup() {
  u8g.setFont(u8g_font_profont12); // Pocice de matrices de 6x10 pixels lettres MAJ/min comprises.
  Serial.begin(115200); pinMode(LED_Verte, OUTPUT); pinMode(BUZZER, OUTPUT); digitalWrite(BUZZER, LOW);
  TEXTE[0] = '\0'; // Au départ la chaine est vide.
  Afficher_les_consignes(); Initialiser_les_valeurs();}
  
void loop() {
  // ++++++++++++++++++++ Traiter la saisie d'une chaîne de caractères ++++++++++++++++
  while((Serial.available() > 0) && (I < (TailleTexte-1))) // Si FIFO non vide lire les caractères.
    {TEXTE[I] = Serial.read(); I++; delay(5);} // Délai impératif.
  TEXTE[I] = '\0'; // Placer le délimiteur de fin de texte.
  // Purger entièrement le FIFO si plus de LGR_MAX caractères envoyés.
  while(Serial.available() > 0) {Serial.read(); delay(5);}
  // Afficher la chaine de caractères contenue dans TEXTE. 
  if (I > 0) {
  //   ACR_sur_LED_Arduino();
     Serial.println(); Serial.print("Consigne USB = "); Serial.print(TEXTE);
     CAR = char(TEXTE[0]); Extraire_Argument();
     Serial.print("  ARGUMENT = "); Serial.println(ARGUMENT);
     // Traiter la consigne reçue.
     switch (CAR) {
        case 'j' : {Traiter_J(); break;}
        case 'J' : {Traiter_J(); break;}
        case 'M' : {Traiter_M(); break;} // ATTENTION : Majuscule pour le mois.
        case 'a' : {Traiter_A(); break;}
        case 'A' : {Traiter_A(); break;}
        case 'h' : {Traiter_H(); break;}
        case 'H' : {Traiter_H(); break;}
        case 'm' : {Traiter_m(); break;} // ATTENTION : Minuscule pour les minutes.
        case 's' : {Traiter_S(); break;}   
        case 'S' : {Traiter_S(); break;}
        case 'n' : {Traiter_N(); break;}   
        case 'N' : {Traiter_N(); break;}
        case 'c' : {Afficher_les_consignes(); break;}
        case 'C' : {Afficher_les_consignes(); break;}
        default : {Serial.print("Consigne non valide."); BIP();}} 
     I=0; } // Commande "vidée".
  // ++++++++++++++++++++++++++ Réalisé une fois par seconde. +++++++++++++++++++++++++
  if (millis() > Ancienne_valeur_Temps_Ecoule_depuis_RESET)  {
      Ancienne_valeur_Temps_Ecoule_depuis_RESET = millis() + T_base_millisecondes; // Réarme le processus.
      digitalWrite(LED_Verte,!digitalRead(LED_Verte));} // Inverser l'état de la LED verte.
  // +++++++++++++++++++++ Traiter la requête de l'un des deux B.P. +++++++++++++++++++
  PAGE1();}
  
void Initialiser_les_valeurs() {
  Heures = rtc.getHour(); Minutes = rtc.getMinute(); Secondes = rtc.getSecond();
  Jour = rtc.getDay(); Mois = rtc.getMonth(); Annee = rtc.getYear(); J_Semaire = rtc.getWeekday();}
  
void PAGE1() {
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  u8g.drawFrame(0,0,128,16); u8g.drawFrame(0,19,128, 43); // Trace les deux cadres.
  //-------- Affiche la tension de la pile de sauvegarde ---------
  Mesure_U_Pile_Horloge(); Aff_TEXTE(17, 12, "U pile SAV = ");
  u8g.print(U_Pile_Horloge,1); u8g.print("v");
  //---------------------- Afficher le jour ----------------------
  u8g.setPrintPos(18,33); Afficher_le_jour_de_la_semaine(); u8g.print(" "); u8g.print(rtc.getDay()); u8g.print(" ");
  u8g.print(rtc.getMonth()); u8g.print(" 20"); u8g.print(rtc.getYear());
  //---------------------- Afficher l'heure ----------------------
  u8g.setPrintPos(10,28); u8g.setScale2x2();
  u8g.print(rtc.formatTime()); u8g.undoScale();}
  //====================================================================
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.
  
void AFF_J() {if (Jour < 10) u8g.print("0"); u8g.print(Jour); u8g.print(" ");}
void AFF_M() {if (Mois < 10) u8g.print("0"); u8g.print(Mois); u8g.print(" 20");}

void Afficher_le_jour_de_la_semaine() {J_Semaire = rtc.getWeekday();
  switch (J_Semaire) {
    case 1 : {u8g.print("Lundi"); break;}
    case 2 : {u8g.print("Mardi"); break;}
    case 3 : {u8g.print("Mercredi"); break;}
    case 4 : {u8g.print("Jeudi"); break;}
    case 5 : {u8g.print("Vendredi"); break;}
    case 6 : {u8g.print("Samedi"); break;}
    case 7 :  u8g.print("Dimanche");}}
  
void Aff_TEXTE(byte X, byte Y, char TEXTE[]) {// Choisir Y=9 pour tous les titres.
  char Caractere; byte I = 0;
  while (Caractere !=0) {Caractere = TEXTE[I]; u8g.setPrintPos((I*6)+X, Y); I++; u8g.print(Caractere);}}
  
void Extraire_Argument() {
   for(byte J = 0; J < I; J++) {TEXTE[J] = TEXTE[J+1];  ARGUMENT = atoi(TEXTE); } }
  
void INITIALISER_horloge(){
  rtc.initClock(); // Instruction qui force à 01 les divers registre. Semble inutile.
  // Ci-dessous : Jour du mois, Jour dans la semaine, Mois, Siècle (1=1900, 0=2000), Année (0-99)
  rtc.setDate (Jour, J_Semaire, Mois, 0, Annee);
  rtc.setTime(Heures, Minutes, Secondes);} // Dans l'ordre on impose : Heures, Minutes, Secondes.

void BIP() {tone(BUZZER,3000,100); digitalWrite(BUZZER, LOW);}

void BIP_Limite() {BIP(); Serial.print("  (Hors limites.)");} 

void Traiter_J() {
  if ((ARGUMENT > 31) || (ARGUMENT < 1)) BIP_Limite(); else {Jour = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_M() {
  if ((ARGUMENT > 12) || (ARGUMENT < 1)) BIP_Limite(); else {Mois = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_A() {
  if ((ARGUMENT > 99) || (ARGUMENT < 18)) BIP_Limite(); else {Annee = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_H() {
  if ((ARGUMENT > 23) || (ARGUMENT < 0)) BIP_Limite(); else {Heures = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_m() {
  if ((ARGUMENT > 59) || (ARGUMENT < 0)) BIP_Limite(); else {Minutes = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_S() {
  if ((ARGUMENT > 59) || (ARGUMENT < 0)) BIP_Limite(); else {Secondes = ARGUMENT; INITIALISER_horloge();}}
  
void Traiter_N() {
  if ((ARGUMENT > 7) || (ARGUMENT < 1)) BIP_Limite(); else {J_Semaire = ARGUMENT; INITIALISER_horloge();}}
  
void Afficher_les_consignes() {
  Serial.println("Donner les consignes par un caractere.");
  Serial.println("> le caractere est suivi ou non d'un espace :");
  Serial.println("j [1 - 31] pour le Jour, M [1 - 12] Majuscule pour le mois.");
  Serial.println("a [19 - 99] pour l'Annee sur deux chiffres. (Ex 20 pour 2020.)");
  Serial.println("h [0 - 23] pour les Heures, m minuscule [0 - 59] pour les minutes, s [0 - 59] : secondes;");
  Serial.println("n [1 - 7] pour Nommer le jour de la semaine. (Lundi = 1, Mardi = 2 ...)");
  Serial.println("c : Redonne ces consignes.");}
  
void Mesure_U_Pile_Horloge() {
  U_Pile_Horloge = analogRead(Entree_U_Pile_Horloge); // L'entier de numérisation passe dans le réel U_Solaire
  U_Pile_Horloge = (U_Pile_Horloge * Correction_U_Pile_sauvegarde);} // 0.0044965 = 0.92 x 5 / 1023.





